#ifndef CONTROLWORKER_H
#define CONTROLWORKER_H

#include <QObject>
#include <QStringList>
#include "frontend_common.h"

class ControlWorker : public QObject
{
    Q_OBJECT
public:
    explicit ControlWorker(QObject *parent = 0);
    ~ControlWorker();

signals:
    void gotNodes(QStringList nodes);
    void gotParams(QStringList params);
    void gotParamValue(QString node, QString param, float value);
    void gotConstantBlocks(QStringList blocks);
    void paramSet(QString node, QString param);

public slots:
    void connectBackend();
    void disconnectBackend();
    void getNodes();
    void getParams(QString node);
    void getParamValue(QString node, QString param);
    void setParamValue(QString node, QString name, float value);

private:
    struct backend_conn * conn;

};

#endif // CONTROLWORKER_H
