#include "hw_impl_unix.h"

struct UARTDriver create_unix_uart() {
  struct UARTDriver uart;
  uart.state = NULL;
  uart.reset = unix_uart_reset;
  uart.write = unix_uart_write;
  uart.read = unix_uart_read;
  return uart;
}

struct PWMOutputDriver create_unix_pwm_outputs() {
  struct PWMOutputDriver pwm_outputs;
  pwm_outputs.state = NULL;
  pwm_outputs.reset = unix_pwm_output_reset;
  pwm_outputs.write = unix_pwm_output_write;
  return pwm_outputs;
}

struct PWMInputDriver create_unix_pwm_inputs() {
  struct PWMInputDriver pwm_inputs;
  pwm_inputs.state = NULL;
  pwm_inputs.reset = unix_pwm_input_reset;
  pwm_inputs.read = unix_pwm_input_read;
  return pwm_inputs;
}

struct I2CDriver create_unix_i2c() {
  struct I2CDriver i2c;
  i2c.state = NULL;
  i2c.reset = unix_i2c_reset;
  i2c.write = unix_i2c_write;
  i2c.read = unix_i2c_read;
  return i2c;
}

struct TimerDriver create_unix_global_timer() {
  struct TimerDriver global_timer;
  global_timer.state = NULL;
  global_timer.reset = unix_global_timer_reset;
  global_timer.restart = unix_global_timer_restart;
  global_timer.read = unix_global_timer_read;
  return global_timer;
}

struct TimerDriver create_unix_axi_timer() {
  struct TimerDriver axi_timer;
  axi_timer.state = NULL;
  axi_timer.reset = unix_axi_timer_reset;
  axi_timer.restart = unix_axi_timer_restart;
  axi_timer.read = unix_axi_timer_read;
  return axi_timer;
}

struct LEDDriver create_unix_mio7_led() {
  struct LEDDriver mio7_led;
  mio7_led.state = NULL;
  mio7_led.reset = unix_mio7_led_reset;
  mio7_led.turn_on = unix_mio7_led_turn_on;
  mio7_led.turn_off = unix_mio7_led_turn_off;
  return mio7_led;
}

struct SystemDriver create_unix_system() {
  struct SystemDriver sys;
  sys.state = NULL;
  sys.reset = unix_system_reset;
  sys.sleep = unix_system_sleep;
  return sys;
}
